package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.eam_core.domain.EMBrand;
import cn.ibizlab.eam.core.eam_core.filter.EMBrandSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMBrand] 服务对象接口
 */
public interface IEMBrandService extends IService<EMBrand>{

    boolean create(EMBrand et) ;
    void createBatch(List<EMBrand> list) ;
    EMBrand get(String key) ;
    boolean save(EMBrand et) ;
    void saveBatch(List<EMBrand> list) ;
    EMBrand getDraft(EMBrand et) ;
    boolean update(EMBrand et) ;
    void updateBatch(List<EMBrand> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(EMBrand et) ;
    Page<EMBrand> searchDefault(EMBrandSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EMBrand> getEmbrandByIds(List<String> ids) ;
    List<EMBrand> getEmbrandByEntities(List<EMBrand> entities) ;

}


